#ifndef MATHLIB_PLANE_H
#define MATHLIB_PLANE_H

#include <mathlib/matrix.h>

namespace mathlib {

template<int ND>
class plane {
public:
	vector<ND> n;
	float D;

	plane() {}
	plane(const vector<ND> &n_, float d) : n(n_), D(d) {}
};

template<int D>
class parameter_plane {
public:
	vector<D> v, u;

	parameter_plane(const vector<D> &v_, const vector<D> &u_)
		: v(v_), u(u_) {}
	parameter_plane(const plane<D> &);

	operator plane<D>() const;
};

template<int ND> inline
float alignment(const plane<ND> &p, const vector<ND> &v)
{
	return dot(p.n, v) + p.D;
}

} // namespace mathlib

#endif
